org.jboss.resteasy.core

## Class ThreadLocalResteasyProviderFactory

- java.lang.Object
- - javax.ws.rs.ext.RuntimeDelegate
  - - org.jboss.resteasy.spi.ResteasyProviderFactory
    - - org.jboss.resteasy.core.ThreadLocalResteasyProviderFactory

- All Implemented Interfaces:
    Configurable<ResteasyProviderFactory>, Configuration, Providers, HeaderValueProcessor, ProviderFactoryDelegate

      public class ThreadLocalResteasyProviderFactory
      extends ResteasyProviderFactory
      implements ProviderFactoryDelegate

  Allow applications to push/pop provider factories onto the stack
  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.jboss.resteasy.spi.ResteasyProviderFactory

      `ResteasyProviderFactory.SortedKey<T>`

    - ### Nested classes/interfaces inherited from class javax.ws.rs.ext.RuntimeDelegate

      `RuntimeDelegate.HeaderDelegate<T>`

  - ### Field Summary

    - ### Fields inherited from class org.jboss.resteasy.spi.ResteasyProviderFactory

      `builtinsRegistered, classContracts, clientDynamicFeatures, clientErrorInterceptors, clientExceptionMappers, clientExecutionInterceptorRegistry, clientMessageBodyReaders, clientMessageBodyWriters, clientReaderInterceptorRegistry, clientRequestFilters, clientResponseFilters, clientWriterInterceptorRegistry, containerRequestFilterRegistry, containerResponseFilterRegistry, contextResolvers, contextualData, enabledFeatures, exceptionMappers, featureClasses, featureInstances, headerDelegates, injectorFactory, instance, maxForwards, paramConverterProviders, parent, pfr, precedence, properties, providerClasses, providerInstances, registerBuiltinByDefault, registerBuiltins, serverDynamicFeatures, serverMessageBodyReaders, serverMessageBodyWriters, serverReaderInterceptorRegistry, serverWriterInterceptorRegistry, stringConverters, stringParameterUnmarshallers`

    - ### Fields inherited from class javax.ws.rs.ext.RuntimeDelegate

      `JAXRS_RUNTIME_DELEGATE_PROPERTY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ThreadLocalResteasyProviderFactory(ResteasyProviderFactory defaultFactory)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClientErrorInterceptor(ClientErrorInterceptor handler)` Add a `ClientErrorInterceptor` to this provider factory instance.
    `void` | `addClientExceptionMapper(Class<? extends ClientExceptionMapper<?>> providerClass)`
    `void` | `addClientExceptionMapper(ClientExceptionMapper<?> provider)`
    `void` | `addClientExceptionMapper(ClientExceptionMapper<?> provider, Class<?> providerClass)`
    `void` | `addClientExceptionMapper(ClientExceptionMapper<?> provider, Type exceptionType)`
    `void` | `addHeaderDelegate(Class clazz, RuntimeDelegate.HeaderDelegate header)`
    `void` | `addStringParameterUnmarshaller(Class<? extends StringParameterUnmarshaller> provider)`
    `void` | `appendInterceptorPrecedence(String precedence)` Append interceptor predence
    `<T> ConstructorInjector` | `createConstructorInjector(Class<? extends T> clazz)`
    `<T> T` | `createEndpoint(Application applicationConfig, Class<T> endpointType)` this is a spec method that is unsupported.
    `<T> RuntimeDelegate.HeaderDelegate<T>` | `createHeaderDelegate(Class<T> tClass)` Obtain an instance of a `RuntimeDelegate.HeaderDelegate` for the supplied class.
    `Link.Builder` | `createLinkBuilder()` Create a new instance of a `Link.Builder`.
    `<T> T` | `createProviderInstance(Class<? extends T> clazz)` Create an instance of a class using provider allocation rules of the specification as well as the InjectorFactory only does constructor injection
    `Response.ResponseBuilder` | `createResponseBuilder()` Create a new instance of a `Response.ResponseBuilder`.
    `<T> StringParameterUnmarshaller<T>` | `createStringParameterUnmarshaller(Class<T> clazz)`
    `UriBuilder` | `createUriBuilder()` Create a new instance of a `UriBuilder`.
    `Variant.VariantListBuilder` | `createVariantListBuilder()` Create a new instance of a `Variant.VariantListBuilder`.
    `Map<Class<?>,Map<Class<?>,Integer>>` | `getClassContracts()`
    `Set<Class<?>>` | `getClasses()` Get the immutable set of registered JAX-RS component (such as provider or `feature`) classes to be instantiated, injected and utilized in the scope of the configurable instance.
    `Set<DynamicFeature>` | `getClientDynamicFeatures()`
    `List<ClientErrorInterceptor>` | `getClientErrorInterceptors()` Return the list of currently registered `ClientErrorInterceptor` instances.
    `<T extends Throwable> ClientExceptionMapper<T>` | `getClientExceptionMapper(Class<T> type)`
    `InterceptorRegistry<ClientExecutionInterceptor>` | `getClientExecutionInterceptorRegistry()`
    `<T> MessageBodyReader<T>` | `getClientMessageBodyReader(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType)`
    `<T> MessageBodyWriter<T>` | `getClientMessageBodyWriter(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType)`
    `ReaderInterceptorRegistry` | `getClientReaderInterceptorRegistry()`
    `JaxrsInterceptorRegistry<ClientRequestFilter>` | `getClientRequestFilters()`
    `ClientResponseFilterRegistry` | `getClientResponseFilters()`
    `WriterInterceptorRegistry` | `getClientWriterInterceptorRegistry()`
    `MediaType` | `getConcreteMediaTypeFromMessageBodyWriters(Class type, Type genericType, Annotation[] annotations, MediaType mediaType)`
    `Configuration` | `getConfiguration()` Get a live view of an internal configuration state of this configurable instance.
    `ContainerRequestFilterRegistry` | `getContainerRequestFilterRegistry()`
    `ContainerResponseFilterRegistry` | `getContainerResponseFilterRegistry()`
    `<T> ContextResolver<T>` | `getContextResolver(Class<T> contextType, MediaType mediaType)` Get a context resolver for a particular type of context and media type.
    `List<ContextResolver>` | `getContextResolvers(Class<?> clazz, MediaType type)`
    `Map<Class<?>,Integer>` | `getContracts(Class<?> componentClass)` Get the extension contract registration information for a component of a given class.
    `ResteasyProviderFactory` | `getDelegate()`
    `Collection<Feature>` | `getEnabledFeatures()`
    `<T extends Throwable> ExceptionMapper<T>` | `getExceptionMapper(Class<T> type)` Get an exception mapping provider for a particular class of exception.
    `Map<Class<?>,ExceptionMapper>` | `getExceptionMappers()`
    `Set<Class<?>>` | `getFeatureClasses()`
    `Set<Object>` | `getFeatureInstances()`
    `RuntimeDelegate.HeaderDelegate` | `getHeaderDelegate(Class<?> aClass)` Checks to see if RuntimeDelegate is a ResteasyProviderFactory If it is, then use that, otherwise use this
    `InjectorFactory` | `getInjectorFactory()`
    `Set<Object>` | `getInstances()` Get the immutable set of registered JAX-RS component (such as provider or `feature`) instances to be utilized by the configurable instance.
    `<T> MessageBodyReader<T>` | `getMessageBodyReader(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Always returns server MBRs
    `<T> MessageBodyWriter<T>` | `getMessageBodyWriter(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Always gets server MBW
    `Map<String,Object>` | `getMutableProperties()`
    `ParamConverter` | `getParamConverter(Class clazz, Type genericType, Annotation[] annotations)`
    `ResteasyProviderFactory` | `getParent()`
    `Map<String,Object>` | `getProperties()` Get the immutable bag of configuration properties.
    `Object` | `getProperty(String name)` Get the value for the property with a given name.
    `Collection<String>` | `getPropertyNames()` Returns an immutable `collection` containing the property names available within the context of the current configuration instance.
    `Set<Class<?>>` | `getProviderClasses()` Copy
    `Set<Object>` | `getProviderInstances()` Copy
    `RuntimeType` | `getRuntimeType()` Get the runtime type of this configuration context.
    `Set<DynamicFeature>` | `getServerDynamicFeatures()`
    `<T> MessageBodyReader<T>` | `getServerMessageBodyReader(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType)`
    `<T> MessageBodyWriter<T>` | `getServerMessageBodyWriter(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType)`
    `ReaderInterceptorRegistry` | `getServerReaderInterceptorRegistry()`
    `WriterInterceptorRegistry` | `getServerWriterInterceptorRegistry()`
    `StringConverter` | `getStringConverter(Class<?> clazz)`
    `protected void` | `initialize()`
    `<T> T` | `injectedInstance(Class<? extends T> clazz)` Property and constructor injection using the InjectorFactory
    `<T> T` | `injectedInstance(Class<? extends T> clazz, HttpRequest request, HttpResponse response)` Property and constructor injection using the InjectorFactory
    `void` | `injectProperties(Class declaring, Object obj)`
    `void` | `injectProperties(Object obj)`
    `void` | `injectProperties(Object obj, HttpRequest request, HttpResponse response)`
    `void` | `insertInterceptorPrecedenceAfter(String after, String newPrecedence)`
    `void` | `insertInterceptorPrecedenceBefore(String before, String newPrecedence)`
    `boolean` | `isBuiltinsRegistered()`
    `boolean` | `isEnabled(Class<? extends Feature> featureClass)` Check if a `feature` instance of `featureClass` class has been previously enabled in the runtime configuration context.
    `boolean` | `isEnabled(Feature feature)` Check if a particular `feature` instance has been previously enabled in the runtime configuration context.
    `boolean` | `isRegisterBuiltins()`
    `boolean` | `isRegistered(Class<?> componentClass)` Check if a JAX-RS component of the supplied `componentClass` class has been previously registered in the runtime configuration context.
    `boolean` | `isRegistered(Object component)` Check if a particular JAX-RS `component` instance (such as providers or `features`) has been previously registered in the runtime configuration context.
    `static void` | `pop()`
    `ResteasyProviderFactory` | `property(String name, Object value)` Set the new configuration property, if already set, the existing value of the property will be updated.
    `static void` | `push(ResteasyProviderFactory factory)`
    `ResteasyProviderFactory` | `register(Class<?> providerClass)` Register a class of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.
    `ResteasyProviderFactory` | `register(Class<?> componentClass, Class<?>... contracts)` Register a class of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.
    `ResteasyProviderFactory` | `register(Class<?> componentClass, int priority)` Register a class of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.
    `ResteasyProviderFactory` | `register(Class<?> componentClass, Map<Class<?>,Integer> contracts)` Register a class of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.
    `ResteasyProviderFactory` | `register(Object provider)` Register an instance of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.
    `ResteasyProviderFactory` | `register(Object component, Class<?>... contracts)` Register an instance of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.
    `ResteasyProviderFactory` | `register(Object component, int priority)` Register an instance of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.
    `ResteasyProviderFactory` | `register(Object component, Map<Class<?>,Integer> contracts)` Register an instance of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.
    `void` | `registerProvider(Class provider)`
    `void` | `registerProvider(Class provider, boolean isBuiltin)` Register a @Provider class.
    `void` | `registerProvider(Class provider, Integer priorityOverride, boolean isBuiltin, Map<Class<?>,Integer> contracts)`
    `void` | `registerProviderInstance(Object provider)` Register a @Provider object.
    `void` | `registerProviderInstance(Object provider, Map<Class<?>,Integer> contracts, Integer defaultPriority, boolean builtIn)`
    `void` | `setBuiltinsRegistered(boolean builtinsRegistered)`
    `void` | `setInjectorFactory(InjectorFactory injectorFactory)`
    `ResteasyProviderFactory` | `setProperties(Map<String,?> properties)`
    `void` | `setRegisterBuiltins(boolean registerBuiltins)`
    `String` | `toHeaderString(Object object)` Convert an object to a header string.
    `String` | `toString(Object object, Class clazz, Type genericType, Annotation[] annotations)` Convert an object to a string.

    - ### Methods inherited from class org.jboss.resteasy.spi.ResteasyProviderFactory

      `addClientMessageBodyReader, addClientMessageBodyWriter, addContextDataLevel, addContextResolver, addContextResolver, addContextResolver, addContextResolver, addContextResolver, addExceptionMapper, addExceptionMapper, addExceptionMapper, addExceptionMapper, addMessageBodyReader, addMessageBodyReader, addMessageBodyReader, addMessageBodyReader, addMessageBodyWriter, addMessageBodyWriter, addMessageBodyWriter, addServerMessageBodyReader, addServerMessageBodyWriter, addStringConverter, addStringConverter, addStringConverter, addStringConverter, clearContextData, clearInstanceIfEqual, createHeaderDelegateFromInterfaces, getClientExceptionMappers, getClientMessageBodyReaders, getClientMessageBodyWriters, getContextData, getContextDataLevelCount, getContextDataMap, getContextResolvers, getHeaderDelegates, getInstance, getParamConverterProviders, getPrecedence, getPriority, getServerMessageBodyReaders, getServerMessageBodyWriters, getStringConverters, getStringParameterUnmarshallers, isA, isA, peekInstance, popContextData, pushContext, pushContextDataMap, registerDefaultInterceptorPrecedences, registerDefaultInterceptorPrecedences, removeContextDataLevel, resolveMessageBodyReader, resolveMessageBodyWriter, setInstance, setRegisterBuiltinByDefault`

    - ### Methods inherited from class javax.ws.rs.ext.RuntimeDelegate

      `setInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ThreadLocalResteasyProviderFactory

          public ThreadLocalResteasyProviderFactory(ResteasyProviderFactory defaultFactory)

  - ### Method Detail

    - #### getDelegate

          public ResteasyProviderFactory getDelegate()

      Specified by:
        `getDelegate` in interface `ProviderFactoryDelegate`

    - #### initialize

          protected void initialize()

      Overrides:
        `initialize` in class `ResteasyProviderFactory`

    - #### getConcreteMediaTypeFromMessageBodyWriters

          public MediaType getConcreteMediaTypeFromMessageBodyWriters(Class type,
                                                             Type genericType,
                                                             Annotation[] annotations,
                                                             MediaType mediaType)

      Overrides:
        `getConcreteMediaTypeFromMessageBodyWriters` in class `ResteasyProviderFactory`

    - #### getHeaderDelegate

          public RuntimeDelegate.HeaderDelegate getHeaderDelegate(Class<?> aClass)

      Description copied from class: `ResteasyProviderFactory`
      Checks to see if RuntimeDelegate is a ResteasyProviderFactory If it is, then use that, otherwise use this
      Overrides:
        `getHeaderDelegate` in class `ResteasyProviderFactory`
      Returns:

    - #### injectedInstance

          public <T> T injectedInstance(Class<? extends T> clazz,
                               HttpRequest request,
                               HttpResponse response)

      Description copied from class: `ResteasyProviderFactory`
      Property and constructor injection using the InjectorFactory
      Overrides:
        `injectedInstance` in class `ResteasyProviderFactory`
      Returns:

    - #### injectProperties

          public void injectProperties(Object obj,
                              HttpRequest request,
                              HttpResponse response)

      Overrides:
        `injectProperties` in class `ResteasyProviderFactory`

    - #### push

          public static void push(ResteasyProviderFactory factory)

    - #### pop

          public static void pop()

    - #### getContainerResponseFilterRegistry

          public ContainerResponseFilterRegistry getContainerResponseFilterRegistry()

      Overrides:
        `getContainerResponseFilterRegistry` in class `ResteasyProviderFactory`

    - #### getServerReaderInterceptorRegistry

          public ReaderInterceptorRegistry getServerReaderInterceptorRegistry()

      Overrides:
        `getServerReaderInterceptorRegistry` in class `ResteasyProviderFactory`

    - #### createVariantListBuilder

          public Variant.VariantListBuilder createVariantListBuilder()

      Description copied from class: `RuntimeDelegate`
      Create a new instance of a `Variant.VariantListBuilder`.
      Overrides:
        `createVariantListBuilder` in class `ResteasyProviderFactory`
      Returns:
        new `VariantListBuilder` instance.
      See Also:
        `Variant.VariantListBuilder`

    - #### getContextResolvers

          public List<ContextResolver> getContextResolvers(Class<?> clazz,
                                                  MediaType type)

      Overrides:
        `getContextResolvers` in class `ResteasyProviderFactory`

    - #### isBuiltinsRegistered

          public boolean isBuiltinsRegistered()

      Overrides:
        `isBuiltinsRegistered` in class `ResteasyProviderFactory`

    - #### getClientExceptionMapper

          public <T extends Throwable> ClientExceptionMapper<T> getClientExceptionMapper(Class<T> type)

      Overrides:
        `getClientExceptionMapper` in class `ResteasyProviderFactory`

    - #### getFeatureClasses

          public Set<Class<?>> getFeatureClasses()

      Overrides:
        `getFeatureClasses` in class `ResteasyProviderFactory`

    - #### setBuiltinsRegistered

          public void setBuiltinsRegistered(boolean builtinsRegistered)

      Overrides:
        `setBuiltinsRegistered` in class `ResteasyProviderFactory`

    - #### register

          public ResteasyProviderFactory register(Class<?> providerClass)

      Description copied from interface: `Configurable`
      Register a class of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context. Implementations SHOULD warn about and ignore registrations that do not conform to the requirements of supported JAX-RS component types in the given configurable context. Any subsequent registration attempts for a component type, for which a class or instance-based registration already exists in the system MUST be rejected by the JAX-RS implementation and a warning SHOULD be raised to inform the user about the rejected registration. The registered JAX-RS component class is registered as a contract provider of all the recognized JAX-RS or implementation-specific extension contracts including meta-provider contracts, such as `Feature` or `DynamicFeature`.

      As opposed to component instances registered via `Configurable.register(Object)` method, the lifecycle of components registered using this class-based `register(...)` method is fully managed by the JAX-RS implementation or any underlying IoC container supported by the implementation.

      Specified by:
        `register` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `register` in class `ResteasyProviderFactory`
      Parameters:
        `providerClass` - JAX-RS component class to be configured in the scope of this configurable context.
      Returns:
        the updated configurable context.

    - #### getClientDynamicFeatures

          public Set<DynamicFeature> getClientDynamicFeatures()

      Overrides:
        `getClientDynamicFeatures` in class `ResteasyProviderFactory`

    - #### addClientExceptionMapper

          public void addClientExceptionMapper(Class<? extends ClientExceptionMapper<?>> providerClass)

      Overrides:
        `addClientExceptionMapper` in class `ResteasyProviderFactory`

    - #### register

          public ResteasyProviderFactory register(Class<?> componentClass,
                                         Map<Class<?>,Integer> contracts)

      Description copied from interface: `Configurable`
      Register a class of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.

      This registration method provides same functionality as `Configurable.register(Class, Class[])` except that any priority specified on the registered JAX-RS component class via `javax.annotation.Priority` annotation is overridden for each extension provider contract type separately with an integer priority value specified as a value in the supplied map of [contract type, priority] pairs.

      Note that in case a priority is not applicable to a provider contract registered for the JAX-RS component, the supplied priority value is ignored for such contract.

      Specified by:
        `register` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `register` in class `ResteasyProviderFactory`
      Parameters:
        `componentClass` - JAX-RS component class to be configured in the scope of this configurable context.
        `contracts` - map of the specific extension provider and meta-provider contracts and their associated priorities for which the JAX-RS component is registered. All contracts in the map must represent a class or an interface implemented or extended by the JAX-RS component. Contracts that are not `assignable from` the registered component class MUST be ignored and implementations SHOULD raise a warning to inform users about the ignored contract(s).
      Returns:
        the updated configurable context.

    - #### getEnabledFeatures

          public Collection<Feature> getEnabledFeatures()

      Overrides:
        `getEnabledFeatures` in class `ResteasyProviderFactory`

    - #### createResponseBuilder

          public Response.ResponseBuilder createResponseBuilder()

      Description copied from class: `RuntimeDelegate`
      Create a new instance of a `Response.ResponseBuilder`.
      Overrides:
        `createResponseBuilder` in class `ResteasyProviderFactory`
      Returns:
        new `ResponseBuilder` instance.
      See Also:
        `Response.ResponseBuilder`

    - #### registerProviderInstance

          public void registerProviderInstance(Object provider)

      Description copied from class: `ResteasyProviderFactory`
      Register a @Provider object. Can be a MessageBodyReader/Writer or ExceptionMapper.
      Overrides:
        `registerProviderInstance` in class `ResteasyProviderFactory`

    - #### addClientExceptionMapper

          public void addClientExceptionMapper(ClientExceptionMapper<?> provider,
                                      Type exceptionType)

      Overrides:
        `addClientExceptionMapper` in class `ResteasyProviderFactory`

    - #### getStringConverter

          public StringConverter getStringConverter(Class<?> clazz)

      Overrides:
        `getStringConverter` in class `ResteasyProviderFactory`

    - #### createStringParameterUnmarshaller

          public <T> StringParameterUnmarshaller<T> createStringParameterUnmarshaller(Class<T> clazz)

      Overrides:
        `createStringParameterUnmarshaller` in class `ResteasyProviderFactory`

    - #### getFeatureInstances

          public Set<Object> getFeatureInstances()

      Overrides:
        `getFeatureInstances` in class `ResteasyProviderFactory`

    - #### addClientExceptionMapper

          public void addClientExceptionMapper(ClientExceptionMapper<?> provider)

      Overrides:
        `addClientExceptionMapper` in class `ResteasyProviderFactory`

    - #### setInjectorFactory

          public void setInjectorFactory(InjectorFactory injectorFactory)

      Overrides:
        `setInjectorFactory` in class `ResteasyProviderFactory`

    - #### getInstances

          public Set<Object> getInstances()

      Description copied from interface: `Configuration`
      Get the immutable set of registered JAX-RS component (such as provider or `feature`) instances to be utilized by the configurable instance. Fields and properties of returned instances are injected with their declared dependencies (see `Context`) by the runtime prior to use.

      For each component type, there can be only a single class-based or instance-based registration present in the configuration context at any given time.

      Specified by:
        `getInstances` in interface `Configuration`
      Overrides:
        `getInstances` in class `ResteasyProviderFactory`
      Returns:
        the immutable set of registered JAX-RS component instances. The returned value may be empty but will never be `null`.
      See Also:
        `Configuration.getClasses()`

    - #### isRegistered

          public boolean isRegistered(Object component)

      Description copied from interface: `Configuration`
      Check if a particular JAX-RS `component` instance (such as providers or `features`) has been previously registered in the runtime configuration context.

      Method returns `true` only in case an instance equal to the `component` instance is already present among the components previously registered in the configuration context.

      Specified by:
        `isRegistered` in interface `Configuration`
      Overrides:
        `isRegistered` in class `ResteasyProviderFactory`
      Parameters:
        `component` - a component instance to test for.
      Returns:
        `true` if the component instance has been previously registered in this configuration context, `false` otherwise.
      See Also:
        `Configuration.isEnabled(Feature)`

    - #### register

          public ResteasyProviderFactory register(Class<?> componentClass,
                                         int priority)

      Description copied from interface: `Configurable`
      Register a class of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.

      This registration method provides the same functionality as `Configurable.register(Class)` except that any priority specified on the registered JAX-RS component class via `javax.annotation.Priority` annotation is overridden with the supplied `priority` value.

      Note that in case the priority is not applicable to a particular provider contract implemented by the class of the registered component, the supplied `priority` value will be ignored for that contract.

      Specified by:
        `register` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `register` in class `ResteasyProviderFactory`
      Parameters:
        `componentClass` - JAX-RS component class to be configured in the scope of this configurable context.
        `priority` - the overriding priority for the registered component and all the provider contracts the component implements.
      Returns:
        the updated configurable context.

    - #### getContextResolver

          public <T> ContextResolver<T> getContextResolver(Class<T> contextType,
                                                  MediaType mediaType)

      Description copied from interface: `Providers`
      Get a context resolver for a particular type of context and media type. The set of resolvers is first filtered by comparing the supplied value of `mediaType` with the value of each resolver's `Produces`, ensuring the generic type of the context resolver is assignable to the supplied value of `contextType`, and eliminating those that do not match. If only one resolver matches the criteria then it is returned. If more than one resolver matches then the list of matching resolvers is ordered with those with the best matching values of `Produces` (x/y > x/* > */*) sorted first. A proxy is returned that delegates calls to `ContextResolver.getContext(java.lang.Class)` to each matching context resolver in order and returns the first non-null value it obtains or null if all matching context resolvers return null.
      Specified by:
        `getContextResolver` in interface `Providers`
      Overrides:
        `getContextResolver` in class `ResteasyProviderFactory`
      Type Parameters:
        `T` - type of the context.
      Parameters:
        `contextType` - the class of context desired.
        `mediaType` - the media type of data for which a context is required.
      Returns:
        a matching context resolver instance or `null` if no matching context providers are found.

    - #### getClientExecutionInterceptorRegistry

          public InterceptorRegistry<ClientExecutionInterceptor> getClientExecutionInterceptorRegistry()

      Overrides:
        `getClientExecutionInterceptorRegistry` in class `ResteasyProviderFactory`

    - #### getMessageBodyReader

          public <T> MessageBodyReader<T> getMessageBodyReader(Class<T> type,
                                                      Type genericType,
                                                      Annotation[] annotations,
                                                      MediaType mediaType)

      Description copied from class: `ResteasyProviderFactory`
      Always returns server MBRs
      Specified by:
        `getMessageBodyReader` in interface `Providers`
      Overrides:
        `getMessageBodyReader` in class `ResteasyProviderFactory`
      Type Parameters:
        `T` - type of the the object that is to be read.
      Parameters:
        `type` - the class of the object that is to be read.
        `genericType` - the type of object to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Class.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Class.getParameterAnnotations`.
        `mediaType` - the media type of the data that will be read.
      Returns:
        a MessageBodyReader that matches the supplied criteria or `null` if none is found.

    - #### addClientErrorInterceptor

          public void addClientErrorInterceptor(ClientErrorInterceptor handler)

      Description copied from class: `ResteasyProviderFactory`
      Add a `ClientErrorInterceptor` to this provider factory instance. Duplicate handlers are ignored. (For Client Proxy API only)
      Overrides:
        `addClientErrorInterceptor` in class `ResteasyProviderFactory`

    - #### registerProvider

          public void registerProvider(Class provider,
                              Integer priorityOverride,
                              boolean isBuiltin,
                              Map<Class<?>,Integer> contracts)

      Overrides:
        `registerProvider` in class `ResteasyProviderFactory`

    - #### getClassContracts

          public Map<Class<?>,Map<Class<?>,Integer>> getClassContracts()

      Overrides:
        `getClassContracts` in class `ResteasyProviderFactory`

    - #### getContainerRequestFilterRegistry

          public ContainerRequestFilterRegistry getContainerRequestFilterRegistry()

      Overrides:
        `getContainerRequestFilterRegistry` in class `ResteasyProviderFactory`

    - #### register

          public ResteasyProviderFactory register(Object component,
                                         Map<Class<?>,Integer> contracts)

      Description copied from interface: `Configurable`
      Register an instance of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.

      This registration method provides same functionality as `Configurable.register(Object, Class[])` except that any priority specified on the registered JAX-RS component class via `javax.annotation.Priority` annotation is overridden for each extension provider contract type separately with an integer priority value specified as a value in the supplied map of [contract type, priority] pairs.

      Note that in case a priority is not applicable to a provider contract registered for the JAX-RS component, the supplied priority value is ignored for such contract.

      Specified by:
        `register` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `register` in class `ResteasyProviderFactory`
      Parameters:
        `component` - JAX-RS component instance to be configured in the scope of this configurable context.
        `contracts` - map of the specific extension provider and meta-provider contracts and their associated priorities for which the JAX-RS component is registered. All contracts in the map must represent a class or an interface implemented or extended by the JAX-RS component. Contracts that are not `assignable from` the registered component class MUST be ignored and implementations SHOULD raise a warning to inform users about the ignored contract(s).
      Returns:
        the updated configurable context.

    - #### isRegisterBuiltins

          public boolean isRegisterBuiltins()

      Overrides:
        `isRegisterBuiltins` in class `ResteasyProviderFactory`

    - #### getClientReaderInterceptorRegistry

          public ReaderInterceptorRegistry getClientReaderInterceptorRegistry()

      Overrides:
        `getClientReaderInterceptorRegistry` in class `ResteasyProviderFactory`

    - #### setRegisterBuiltins

          public void setRegisterBuiltins(boolean registerBuiltins)

      Overrides:
        `setRegisterBuiltins` in class `ResteasyProviderFactory`

    - #### register

          public ResteasyProviderFactory register(Object component,
                                         int priority)

      Description copied from interface: `Configurable`
      Register an instance of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.

      This registration method provides the same functionality as `Configurable.register(Object)` except that any priority specified on the registered JAX-RS component class via `javax.annotation.Priority` annotation is overridden with the supplied `priority` value.

      Note that in case the priority is not applicable to a particular provider contract implemented by the class of the registered component, the supplied `priority` value will be ignored for that contract.

      Specified by:
        `register` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `register` in class `ResteasyProviderFactory`
      Parameters:
        `component` - JAX-RS component instance to be configured in the scope of this configurable context.
        `priority` - the overriding priority for the registered component and all the provider contracts the component implements.
      Returns:
        the updated configurable context.

    - #### registerProvider

          public void registerProvider(Class provider,
                              boolean isBuiltin)

      Description copied from class: `ResteasyProviderFactory`
      Register a @Provider class. Can be a MessageBodyReader/Writer or ExceptionMapper.
      Overrides:
        `registerProvider` in class `ResteasyProviderFactory`

    - #### getPropertyNames

          public Collection<String> getPropertyNames()

      Description copied from interface: `Configuration`
      Returns an immutable `collection` containing the property names available within the context of the current configuration instance.

      Use the `Configuration.getProperty(java.lang.String)` method with a property name to get the value of a property.

      Specified by:
        `getPropertyNames` in interface `Configuration`
      Overrides:
        `getPropertyNames` in class `ResteasyProviderFactory`
      Returns:
        an immutable `collection` of property names.
      See Also:
        `Configuration.getProperty(java.lang.String)`

    - #### addClientExceptionMapper

          public void addClientExceptionMapper(ClientExceptionMapper<?> provider,
                                      Class<?> providerClass)

      Overrides:
        `addClientExceptionMapper` in class `ResteasyProviderFactory`

    - #### insertInterceptorPrecedenceAfter

          public void insertInterceptorPrecedenceAfter(String after,
                                              String newPrecedence)

      Overrides:
        `insertInterceptorPrecedenceAfter` in class `ResteasyProviderFactory`
      Parameters:
        `after` - put newPrecedence after this

    - #### register

          public ResteasyProviderFactory register(Object provider)

      Description copied from interface: `Configurable`
      Register an instance of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context. Implementations SHOULD warn about and ignore registrations that do not conform to the requirements of supported JAX-RS component types in the given configurable context. Any subsequent registration attempts for a component type, for which a class or instance-based registration already exists in the system MUST be rejected by the JAX-RS implementation and a warning SHOULD be raised to inform the user about the rejected registration. The registered JAX-RS component is registered as a contract provider of all the recognized JAX-RS or implementation-specific extension contracts including meta-provider contracts, such as `Feature` or `DynamicFeature`.

      As opposed to components registered via `Configurable.register(Class)` method, the lifecycle of providers registered using this instance-based `register(...)` is not managed by JAX-RS runtime. The same registered component instance is used during the whole lifespan of the configurable context. Fields and properties of all registered JAX-RS component instances are injected with their declared dependencies (see `Context`) by the JAX-RS runtime prior to use.

      Specified by:
        `register` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `register` in class `ResteasyProviderFactory`
      Parameters:
        `provider` - JAX-RS component instance to be configured in the scope of this configurable context.
      Returns:
        the updated configurable context.

    - #### createConstructorInjector

          public <T> ConstructorInjector createConstructorInjector(Class<? extends T> clazz)

      Overrides:
        `createConstructorInjector` in class `ResteasyProviderFactory`

    - #### createProviderInstance

          public <T> T createProviderInstance(Class<? extends T> clazz)

      Description copied from class: `ResteasyProviderFactory`
      Create an instance of a class using provider allocation rules of the specification as well as the InjectorFactory

      only does constructor injection
      Overrides:
        `createProviderInstance` in class `ResteasyProviderFactory`
      Returns:

    - #### isRegistered

          public boolean isRegistered(Class<?> componentClass)

      Description copied from interface: `Configuration`
      Check if a JAX-RS component of the supplied `componentClass` class has been previously registered in the runtime configuration context.

      Method returns `true` in case a component of the supplied `componentClass` class is already present among the previously registered component classes or instances in the configuration context.

      Specified by:
        `isRegistered` in interface `Configuration`
      Overrides:
        `isRegistered` in class `ResteasyProviderFactory`
      Parameters:
        `componentClass` - a component class to test for.
      Returns:
        `true` if a component of a given class has been previously registered in this configuration context, `false` otherwise.
      See Also:
        `Configuration.isEnabled(Class)`

    - #### insertInterceptorPrecedenceBefore

          public void insertInterceptorPrecedenceBefore(String before,
                                               String newPrecedence)

      Overrides:
        `insertInterceptorPrecedenceBefore` in class `ResteasyProviderFactory`
      Parameters:
        `before` - put newPrecedence before this

    - #### createEndpoint

          public <T> T createEndpoint(Application applicationConfig,
                             Class<T> endpointType)
                           throws IllegalArgumentException,
                                  UnsupportedOperationException

      Description copied from class: `ResteasyProviderFactory`
      this is a spec method that is unsupported. it is an optional method anyways.
      Overrides:
        `createEndpoint` in class `ResteasyProviderFactory`
      Type Parameters:
        `T` - endpoint type.
      Parameters:
        `applicationConfig` - the application configuration.
        `endpointType` - the type of endpoint instance to be created.
      Returns:
        a configured instance of the requested type.
      Throws:
        `IllegalArgumentException` - if application is null or the requested endpoint type is not supported.
        `UnsupportedOperationException` - if the implementation supports no endpoint types.

    - #### getMutableProperties

          public Map<String,Object> getMutableProperties()

      Overrides:
        `getMutableProperties` in class `ResteasyProviderFactory`

    - #### getServerDynamicFeatures

          public Set<DynamicFeature> getServerDynamicFeatures()

      Overrides:
        `getServerDynamicFeatures` in class `ResteasyProviderFactory`

    - #### isEnabled

          public boolean isEnabled(Feature feature)

      Description copied from interface: `Configuration`
      Check if a particular `feature` instance has been previously enabled in the runtime configuration context.

      Method returns `true` only in case an instance equal to the `feature` instance is already present among the features previously successfully enabled in the configuration context.

      Specified by:
        `isEnabled` in interface `Configuration`
      Overrides:
        `isEnabled` in class `ResteasyProviderFactory`
      Parameters:
        `feature` - a feature instance to test for.
      Returns:
        `true` if the feature instance has been previously enabled in this configuration context, `false` otherwise.

    - #### getProperty

          public Object getProperty(String name)

      Description copied from interface: `Configuration`
      Get the value for the property with a given name.
      Specified by:
        `getProperty` in interface `Configuration`
      Overrides:
        `getProperty` in class `ResteasyProviderFactory`
      Parameters:
        `name` - property name.
      Returns:
        the property value for the specified property name or `null` if the property with such name is not configured.

    - #### getServerWriterInterceptorRegistry

          public WriterInterceptorRegistry getServerWriterInterceptorRegistry()

      Overrides:
        `getServerWriterInterceptorRegistry` in class `ResteasyProviderFactory`

    - #### setProperties

          public ResteasyProviderFactory setProperties(Map<String,?> properties)

      Overrides:
        `setProperties` in class `ResteasyProviderFactory`

    - #### getClientErrorInterceptors

          public List<ClientErrorInterceptor> getClientErrorInterceptors()

      Description copied from class: `ResteasyProviderFactory`
      Return the list of currently registered `ClientErrorInterceptor` instances.
      Overrides:
        `getClientErrorInterceptors` in class `ResteasyProviderFactory`

    - #### injectProperties

          public void injectProperties(Class declaring,
                              Object obj)

      Overrides:
        `injectProperties` in class `ResteasyProviderFactory`

    - #### createUriBuilder

          public UriBuilder createUriBuilder()

      Description copied from class: `RuntimeDelegate`
      Create a new instance of a `UriBuilder`.
      Overrides:
        `createUriBuilder` in class `ResteasyProviderFactory`
      Returns:
        new `UriBuilder` instance.
      See Also:
        `UriBuilder`

    - #### register

          public ResteasyProviderFactory register(Class<?> componentClass,
                                         Class<?>... contracts)

      Description copied from interface: `Configurable`
      Register a class of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.

      This registration method provides the same functionality as `Configurable.register(Class)` except the JAX-RS component class is only registered as a provider of the listed extension provider or meta-provider `contracts`. All explicitly enumerated contract types must represent a class or an interface implemented or extended by the registered component. Contracts that are not `assignable from` the registered component class MUST be ignored and implementations SHOULD raise a warning to inform users about the ignored contract(s).

      Specified by:
        `register` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `register` in class `ResteasyProviderFactory`
      Parameters:
        `componentClass` - JAX-RS component class to be configured in the scope of this configurable context.
        `contracts` - the specific extension provider or meta-provider contracts implemented by the component for which the component should be registered. Implementations MUST ignore attempts to register a component class for an empty or `null` collection of contracts via this method and SHOULD raise a warning about such event.
      Returns:
        the updated configurable context.

    - #### injectedInstance

          public <T> T injectedInstance(Class<? extends T> clazz)

      Description copied from class: `ResteasyProviderFactory`
      Property and constructor injection using the InjectorFactory
      Overrides:
        `injectedInstance` in class `ResteasyProviderFactory`
      Returns:

    - #### appendInterceptorPrecedence

          public void appendInterceptorPrecedence(String precedence)

      Description copied from class: `ResteasyProviderFactory`
      Append interceptor predence
      Overrides:
        `appendInterceptorPrecedence` in class `ResteasyProviderFactory`

    - #### getParent

          public ResteasyProviderFactory getParent()

      Overrides:
        `getParent` in class `ResteasyProviderFactory`

    - #### getRuntimeType

          public RuntimeType getRuntimeType()

      Description copied from interface: `Configuration`
      Get the runtime type of this configuration context.
      Specified by:
        `getRuntimeType` in interface `Configuration`
      Overrides:
        `getRuntimeType` in class `ResteasyProviderFactory`
      Returns:
        configuration context runtime type.

    - #### injectProperties

          public void injectProperties(Object obj)

      Overrides:
        `injectProperties` in class `ResteasyProviderFactory`

    - #### property

          public ResteasyProviderFactory property(String name,
                                         Object value)

      Description copied from interface: `Configurable`
      Set the new configuration property, if already set, the existing value of the property will be updated. Setting a `null` value into a property effectively removes the property from the property bag.
      Specified by:
        `property` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `property` in class `ResteasyProviderFactory`
      Parameters:
        `name` - property name.
        `value` - (new) property value. `null` value removes the property with the given name.
      Returns:
        the updated configurable instance.

    - #### getClientWriterInterceptorRegistry

          public WriterInterceptorRegistry getClientWriterInterceptorRegistry()

      Overrides:
        `getClientWriterInterceptorRegistry` in class `ResteasyProviderFactory`

    - #### getInjectorFactory

          public InjectorFactory getInjectorFactory()

      Overrides:
        `getInjectorFactory` in class `ResteasyProviderFactory`

    - #### getContracts

          public Map<Class<?>,Integer> getContracts(Class<?> componentClass)

      Description copied from interface: `Configuration`
      Get the extension contract registration information for a component of a given class. For component classes that are not configured in this configuration context the method returns an empty `Map`. Method does not return `null`.
      Specified by:
        `getContracts` in interface `Configuration`
      Overrides:
        `getContracts` in class `ResteasyProviderFactory`
      Returns:
        map of extension contracts and their priorities for which the component class is registered. May return an empty map in case the component has not been registered for any extension contract supported by the implementation.

    - #### getParamConverter

          public ParamConverter getParamConverter(Class clazz,
                                         Type genericType,
                                         Annotation[] annotations)

      Overrides:
        `getParamConverter` in class `ResteasyProviderFactory`

    - #### getClientResponseFilters

          public ClientResponseFilterRegistry getClientResponseFilters()

      Overrides:
        `getClientResponseFilters` in class `ResteasyProviderFactory`

    - #### register

          public ResteasyProviderFactory register(Object component,
                                         Class<?>... contracts)

      Description copied from interface: `Configurable`
      Register an instance of a custom JAX-RS component (such as an extension provider or a `feature` meta-provider) to be instantiated and used in the scope of this configurable context.

      This registration method provides the same functionality as `Configurable.register(Object)` except the JAX-RS component class is only registered as a provider of the listed extension provider or meta-provider `contracts`. All explicitly enumerated contract types must represent a class or an interface implemented or extended by the registered component. Contracts that are not `assignable from` the registered component class MUST be ignored and implementations SHOULD raise a warning to inform users about the ignored contract(s).

      Specified by:
        `register` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `register` in class `ResteasyProviderFactory`
      Parameters:
        `component` - JAX-RS component instance to be configured in the scope of this configurable context.
        `contracts` - the specific extension provider or meta-provider contracts implemented by the component for which the component should be registered. Implementations MUST ignore attempts to register a component class for an empty or `null` collection of contracts via this method and SHOULD raise a warning about such event.
      Returns:
        the updated configurable context.

    - #### getClasses

          public Set<Class<?>> getClasses()

      Description copied from interface: `Configuration`
      Get the immutable set of registered JAX-RS component (such as provider or `feature`) classes to be instantiated, injected and utilized in the scope of the configurable instance.

      For each component type, there can be only a single class-based or instance-based registration present in the configuration context at any given time.

      Specified by:
        `getClasses` in interface `Configuration`
      Overrides:
        `getClasses` in class `ResteasyProviderFactory`
      Returns:
        the immutable set of registered JAX-RS component classes. The returned value may be empty but will never be `null`.
      See Also:
        `Configuration.getInstances()`

    - #### isEnabled

          public boolean isEnabled(Class<? extends Feature> featureClass)

      Description copied from interface: `Configuration`
      Check if a `feature` instance of `featureClass` class has been previously enabled in the runtime configuration context.

      Method returns `true` in case any instance of the `featureClass` class is already present among the features previously successfully enabled in the configuration context.

      Specified by:
        `isEnabled` in interface `Configuration`
      Overrides:
        `isEnabled` in class `ResteasyProviderFactory`
      Parameters:
        `featureClass` - a feature class to test for.
      Returns:
        `true` if a feature of a given class has been previously enabled in this configuration context, `false` otherwise.

    - #### registerProvider

          public void registerProvider(Class provider)

      Overrides:
        `registerProvider` in class `ResteasyProviderFactory`

    - #### addHeaderDelegate

          public void addHeaderDelegate(Class clazz,
                               RuntimeDelegate.HeaderDelegate header)

      Overrides:
        `addHeaderDelegate` in class `ResteasyProviderFactory`

    - #### registerProviderInstance

          public void registerProviderInstance(Object provider,
                                      Map<Class<?>,Integer> contracts,
                                      Integer defaultPriority,
                                      boolean builtIn)

      Overrides:
        `registerProviderInstance` in class `ResteasyProviderFactory`

    - #### addStringParameterUnmarshaller

          public void addStringParameterUnmarshaller(Class<? extends StringParameterUnmarshaller> provider)

      Overrides:
        `addStringParameterUnmarshaller` in class `ResteasyProviderFactory`

    - #### getProviderClasses

          public Set<Class<?>> getProviderClasses()

      Description copied from class: `ResteasyProviderFactory`
      Copy
      Overrides:
        `getProviderClasses` in class `ResteasyProviderFactory`
      Returns:

    - #### toString

          public String toString(Object object,
                        Class clazz,
                        Type genericType,
                        Annotation[] annotations)

      Description copied from class: `ResteasyProviderFactory`
      Convert an object to a string. First try StringConverter then, object.ToString()
      Overrides:
        `toString` in class `ResteasyProviderFactory`
      Returns:

    - #### getClientRequestFilters

          public JaxrsInterceptorRegistry<ClientRequestFilter> getClientRequestFilters()

      Overrides:
        `getClientRequestFilters` in class `ResteasyProviderFactory`

    - #### getProperties

          public Map<String,Object> getProperties()

      Description copied from interface: `Configuration`
      Get the immutable bag of configuration properties.
      Specified by:
        `getProperties` in interface `Configuration`
      Overrides:
        `getProperties` in class `ResteasyProviderFactory`
      Returns:
        the immutable view of configuration properties.

    - #### toHeaderString

          public String toHeaderString(Object object)

      Description copied from interface: `HeaderValueProcessor`
      Convert an object to a header string. First try StringConverter, then HeaderDelegate, then object.toString()
      Specified by:
        `toHeaderString` in interface `HeaderValueProcessor`
      Overrides:
        `toHeaderString` in class `ResteasyProviderFactory`
      Returns:

    - #### createLinkBuilder

          public Link.Builder createLinkBuilder()

      Description copied from class: `RuntimeDelegate`
      Create a new instance of a `Link.Builder`.
      Overrides:
        `createLinkBuilder` in class `ResteasyProviderFactory`
      Returns:
        new `Link.Builder` instance.
      See Also:
        `Link.Builder`

    - #### getProviderInstances

          public Set<Object> getProviderInstances()

      Description copied from class: `ResteasyProviderFactory`
      Copy
      Overrides:
        `getProviderInstances` in class `ResteasyProviderFactory`
      Returns:

    - #### getConfiguration

          public Configuration getConfiguration()

      Description copied from interface: `Configurable`
      Get a live view of an internal configuration state of this configurable instance. Any changes made using methods of this `Configurable` instance will be reflected in the returned `Configuration` instance.

      The returned `Configuration` instance and the collection data it provides are not thread-safe wrt. modification made using methods on the parent configurable object.

      Specified by:
        `getConfiguration` in interface `Configurable<ResteasyProviderFactory>`
      Overrides:
        `getConfiguration` in class `ResteasyProviderFactory`
      Returns:
        configuration live view of the internal configuration state.

    - #### getMessageBodyWriter

          public <T> MessageBodyWriter<T> getMessageBodyWriter(Class<T> type,
                                                      Type genericType,
                                                      Annotation[] annotations,
                                                      MediaType mediaType)

      Description copied from class: `ResteasyProviderFactory`
      Always gets server MBW
      Specified by:
        `getMessageBodyWriter` in interface `Providers`
      Overrides:
        `getMessageBodyWriter` in class `ResteasyProviderFactory`
      Type Parameters:
        `T` - type of the object that is to be written.
      Parameters:
        `type` - the class of the object that is to be written.
        `genericType` - the type of object to be written. E.g. if the message body is to be produced from a field, this will be the declared type of the field as returned by `Field.getGenericType`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be written. E.g. if the message body is to be produced from a field, this will be the annotations on that field returned by `Field.getDeclaredAnnotations`.
        `mediaType` - the media type of the data that will be written.
      Returns:
        a MessageBodyReader that matches the supplied criteria or `null` if none is found.

    - #### getExceptionMapper

          public <T extends Throwable> ExceptionMapper<T> getExceptionMapper(Class<T> type)

      Description copied from interface: `Providers`
      Get an exception mapping provider for a particular class of exception. Returns the provider whose generic type is the nearest superclass of `type`.
      Specified by:
        `getExceptionMapper` in interface `Providers`
      Overrides:
        `getExceptionMapper` in class `ResteasyProviderFactory`
      Type Parameters:
        `T` - type of the exception handled by the exception mapping provider.
      Parameters:
        `type` - the class of exception.
      Returns:
        an `ExceptionMapper` for the supplied type or `null` if none is found.

    - #### getExceptionMappers

          public Map<Class<?>,ExceptionMapper> getExceptionMappers()

      Overrides:
        `getExceptionMappers` in class `ResteasyProviderFactory`

    - #### createHeaderDelegate

          public <T> RuntimeDelegate.HeaderDelegate<T> createHeaderDelegate(Class<T> tClass)

      Description copied from class: `RuntimeDelegate`
      Obtain an instance of a `RuntimeDelegate.HeaderDelegate` for the supplied class. An implementation is required to support the following values for type: `CacheControl`, `Cookie`, `EntityTag`, `Link`, `NewCookie`, `MediaType` and `java.util.Date`.
      Overrides:
        `createHeaderDelegate` in class `ResteasyProviderFactory`
      Type Parameters:
        `T` - header type.
      Parameters:
        `tClass` - the class of the header.
      Returns:
        an instance of `HeaderDelegate` for the supplied type.
      See Also:
        `RuntimeDelegate.HeaderDelegate`

    - #### getClientMessageBodyWriter

          public <T> MessageBodyWriter<T> getClientMessageBodyWriter(Class<T> type,
                                                            Type genericType,
                                                            Annotation[] annotations,
                                                            MediaType mediaType)

      Overrides:
        `getClientMessageBodyWriter` in class `ResteasyProviderFactory`

    - #### getClientMessageBodyReader

          public <T> MessageBodyReader<T> getClientMessageBodyReader(Class<T> type,
                                                            Type genericType,
                                                            Annotation[] annotations,
                                                            MediaType mediaType)

      Overrides:
        `getClientMessageBodyReader` in class `ResteasyProviderFactory`

    - #### getServerMessageBodyReader

          public <T> MessageBodyReader<T> getServerMessageBodyReader(Class<T> type,
                                                            Type genericType,
                                                            Annotation[] annotations,
                                                            MediaType mediaType)

      Overrides:
        `getServerMessageBodyReader` in class `ResteasyProviderFactory`

    - #### getServerMessageBodyWriter

          public <T> MessageBodyWriter<T> getServerMessageBodyWriter(Class<T> type,
                                                            Type genericType,
                                                            Annotation[] annotations,
                                                            MediaType mediaType)

      Overrides:
        `getServerMessageBodyWriter` in class `ResteasyProviderFactory`

Copyright © 2014. All Rights Reserved.